<?php
namespace Concrete\Package\EditorPermissions\Controller\SinglePage\Dashboard\System\Basics;

use Concrete\Core\Page\Controller\DashboardSitePageController;
use Concrete\Package\EditorPermissions\Entity\Service\EditorPermission as EditorPermissionService;

class AdvancedEditor extends DashboardSitePageController
{
    public function view()
    {
        $this->requireAsset('javascript', 'editorpermissions');
        $this->requireAsset('css', 'editorpermissions');

        $config = $this->app->make('site')->getSite()->getConfigRepository();

        $this->set('fileManagerEnabled', $config->get('editor.concrete.enable_filemanager'));
        $this->set('sitemapEnabled', $config->get('editor.concrete.enable_sitemap'));
        $selectedHidden = $config->get('editor.ckeditor4.plugins.selected_hidden');

        /* @var \Concrete\Core\Editor\PluginManager $manager */
        $manager = $this->app['editor']->getPluginManager();
        $availablePlugins = $manager->getAvailablePlugins();

        /* @var EditorPermissionService $service */
        $service = $this->app->make(EditorPermissionService::class);

        $plugins = [];
        foreach ($availablePlugins as $key => $plugin) {
            if (!in_array($key, $selectedHidden)) {
                $plugins[$key] = [
                    'name' => $plugin->getName(),
                    'groups' => $service->getPluginUserGroups($key),
                ];
            }
        }

        $this->set('plugins', $plugins);
        $this->set('pluginManager', $manager);
        $this->set('fileMngrAssignedGrps', $service->getPluginUserGroups('filemanager'));
        $this->set('sitemapAssignedGrps', $service->getPluginUserGroups('sitemap'));
    }
}
