<?php
namespace Concrete\Package\EditorPermissions\Entity;

use Concrete\Core\User\Group\Group;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 * @ORM\Table(name="EditorPermissions", options={"comment": "Adding permissions to editor plugins"})
 */
class EditorPermission extends EntityBase
{
    /**
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $ID;

    /**
     * @ORM\Column(name="plugin", type="string")
     */
    protected $plugin;

    /**
     * @ORM\Column(name="userGroupID", type="integer")
     */
    protected $userGroupID;

    /**
     * @var Group
     */
    private $userGroup;

    /**
     * @return mixed
     */
    public function getID()
    {
        return $this->ID;
    }

    /**
     * @return mixed
     */
    public function getPlugin()
    {
        return $this->plugin;
    }

    /**
     * @param mixed $plugin
     */
    public function setPlugin($plugin)
    {
        $this->plugin = $plugin;
    }

    /**
     * @return Group
     */
    public function getUserGroup()
    {
        if (!is_object($this->userGroup) && $this->userGroupID > 0) {
            $this->userGroup = Group::getByID($this->userGroupID);
        }

        return $this->userGroup;
    }

    /**
     * @param Group $userGroup
     */
    public function setUserGroup($userGroup)
    {
        $this->userGroup = $userGroup;
        $this->userGroupID = is_object($userGroup) ? $userGroup->getGroupID() : 0;
    }
}
