<?php
namespace Concrete\Package\EditorPermissions\Entity\Service;

use Concrete\Package\EditorPermissions\Entity\EntityBase;

interface ServiceInterface
{
    /**
     * Gets the repository for the entity class.
     *
     * @return \Doctrine\ORM\EntityRepository
     */
    public function repo();

    /**
     * Create New Entity instance.
     *
     * @return EntityBase Entity object
     */
    public function newEntity();

    /**
     * Finds all entities in the repository.
     *
     * @return EntityBase[] the entities
     */
    public function getList();

    /**
     * Finds the entity by its primary key / identifier.
     *
     * @param mixed    $id          The identifier
     *
     * @return EntityBase|null The entity instance or NULL if the entity can not be found
     */
    public function getByID($id);

    /**
     * Save Entity Data.
     *
     * @param EntityBase $entity
     * @param array $data
     *
     * @return bool
     */
    public function saveData(EntityBase $entity, array $data);

    /**
     * Delete Entity.
     *
     * @param EntityBase $entity
     *
     * @return bool
     */
    public function delete(EntityBase $entity);
}
