<?php
namespace Concrete\Package\EditorPermissions\Plugin;

use Concrete\Package\EditorPermissions\Entity\Service\EditorPermission;

class PermissionsAssigner
{
    /**
     * @var EditorPermission
     */
    private $service;

    /**
     * @var string
     */
    private $plugin;

    public function __construct($plugin, EditorPermission $service)
    {
        $this->plugin = $plugin;
        $this->service = $service;
    }

    /**
     * Assign Groups to Editor.
     *
     * @param $groups
     */
    public function assignGroups($groups)
    {
        $this->reset();

        if (!empty($groups)) {
            $this->service->bulkInsert($this->plugin, $groups);
        }
    }

    /**
     * Reset Editor Permissions.
     */
    public function reset()
    {
        $editorPermissions = $this->service->findByPlugin($this->plugin);

        if (!empty($editorPermissions)) {
            $this->service->bulkDelete($editorPermissions);
        }
    }
}
